void
rbglib_GtkTreeModel__interface_init(gpointer g_iface, gpointer iface_data);

static GtkTreeModelFlags rb_GtkTreeModel_get_flags(GtkTreeModel *_self)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_flags");
    return RVAL2GFLAGS(rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(0)), GTK_TYPE_TREE_MODEL_FLAGS);
}

static gint rb_GtkTreeModel_get_n_columns(GtkTreeModel *_self)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_n_columns");
    return NUM2INT(rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(0)));
}

static GType rb_GtkTreeModel_get_column_type(GtkTreeModel *_self, gint index)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_column_type");
    return CLASS2GTYPE(rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, INT2NUM(index))));
}

static gboolean rb_GtkTreeModel_get_iter(GtkTreeModel *_self, GtkTreeIter *iter, GtkTreePath *path)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_iter");
    VALUE rv;
    rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, TREEPATH2RVAL(path)));
    if (!NIL_P(rv)) *iter = *RVAL2ITR(rv);
    return NIL_P(rv) ? FALSE : TRUE;
}

static GtkTreePath* rb_GtkTreeModel_get_path(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_path");
    VALUE rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter)));
    return NIL_P(rv) ? NULL: RVAL2TREEPATH(rv);
}

static void rb_GtkTreeModel_get_value(GtkTreeModel *_self, GtkTreeIter *iter, gint column, GValue *value)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("get_value");
    VALUE rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(2, ITR2RVAL(iter), INT2NUM(column)));
    g_value_init(value, RVAL2GTYPE(rv));
    rbgobj_rvalue_to_gvalue(rv, value);
}

static gboolean rb_GtkTreeModel_iter_next(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_next");
    VALUE rv;
    rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter)));
    if (!NIL_P(rv)) *iter = *RVAL2ITR(rv);
    return NIL_P(rv) ? FALSE : TRUE;
}

static gboolean rb_GtkTreeModel_iter_children(GtkTreeModel *_self, GtkTreeIter *iter, GtkTreeIter *parent)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_children");
    VALUE rv;
    rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(parent)));
    if (!NIL_P(rv)) *iter = *RVAL2ITR(rv);
    return NIL_P(rv) ? FALSE : TRUE;
}

static gboolean rb_GtkTreeModel_iter_has_child(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_has_child");
    return RTEST(rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter)))) ? TRUE : FALSE;
}

static gint rb_GtkTreeModel_iter_n_children(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_n_children");
    return NUM2INT(rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter))));
}

static gboolean rb_GtkTreeModel_iter_nth_child(GtkTreeModel *_self, GtkTreeIter *iter, GtkTreeIter *parent, gint n)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_nth_child");
    VALUE rv;
    rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(2, ITR2RVAL(parent), INT2NUM(n)));
    if (!NIL_P(rv)) *iter = *RVAL2ITR(rv);
    return NIL_P(rv) ? FALSE : TRUE;
}

static gboolean rb_GtkTreeModel_iter_parent(GtkTreeModel *_self, GtkTreeIter *iter, GtkTreeIter *child)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("iter_parent");
    VALUE rv;
    rv = rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(child)));
    if (!NIL_P(rv)) *iter = *RVAL2ITR(rv);
    return NIL_P(rv) ? FALSE : TRUE;
}

static void rb_GtkTreeModel_ref_node(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("ref_node");
    rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter)));
}

static void rb_GtkTreeModel_unref_node(GtkTreeModel *_self, GtkTreeIter *iter)
{
    static ID iface_symbol = 0;
    if (iface_symbol == 0) iface_symbol = rb_intern("unref_node");
    rbgobj_iface_dispatch(GOBJ2RVAL(_self), iface_symbol, rb_ary_new3(1, ITR2RVAL(iter)));
}

void
rbglib_GtkTreeModel__interface_init(gpointer g_iface, gpointer iface_data)
{
    GtkTreeModelIface *klass = (GtkTreeModelIface *) g_iface;
    klass->get_flags = rb_GtkTreeModel_get_flags;
    klass->get_n_columns = rb_GtkTreeModel_get_n_columns;
    klass->get_column_type = rb_GtkTreeModel_get_column_type;
    klass->get_iter = rb_GtkTreeModel_get_iter;
    klass->get_path = rb_GtkTreeModel_get_path;
    klass->get_value = rb_GtkTreeModel_get_value;
    klass->iter_next = rb_GtkTreeModel_iter_next;
    klass->iter_children = rb_GtkTreeModel_iter_children;
    klass->iter_has_child = rb_GtkTreeModel_iter_has_child;
    klass->iter_n_children = rb_GtkTreeModel_iter_n_children;
    klass->iter_nth_child = rb_GtkTreeModel_iter_nth_child;
    klass->iter_parent = rb_GtkTreeModel_iter_parent;
    klass->ref_node = rb_GtkTreeModel_ref_node;
    klass->unref_node = rb_GtkTreeModel_unref_node;
}
